#!/usr/bin/perl -w

$printacks = 0;
$printdrops = 0;

# mytdg, neil's version of the below.   uses jgraph instead.

# tdg
# TcpDump Grapher
#
# Jeffrey Semke
# Pittsburgh Supercomputing Center
# November 1998

# plot ack numbers and seq numbers from tcpdump hex files

sub match {
    my $src = shift(@_);
    my $dst = shift(@_);
    my $sender = shift(@_);
    my $acker = shift(@_);

    if ($dst =~ /\.(ftp-data|20)$/) {
			return 1; 
		}
    #if ($src =~ /\.(ftp-data|20)$/) {
			#return 1; 
		#}
    #if (((index $src, $sender) >=0)
        #&& ((index $dst, $acker) >=0)) {
        #return 1;
    #}
    return 0;
}

if (($#ARGV < 2 ) || ($#ARGV > 4)) {
    print STDERR "Usage: $0 tcpdump-text-file sender acker [sack] [rwin] | xgraph";
    exit(-1);
}

$input_file = $ARGV[0];

$sender = $ARGV[1];
$acker = $ARGV[2];
$sack = 0;
$rwin = 0;
$rscale = 0;
$last_ack = $last_rwin = 0;

GETARGS: for ($i = 3; $i <= $#ARGV; $i++) {
  if ($ARGV[$i] eq 'sack') {
      $sack = 1;
      next GETARGS;
  }
  if ($ARGV[$i] eq 'rwin') {
      $rwin = 1;
      next GETARGS;
  }
  die "Invalid paramater: $ARGV[$i]\n";
}

if (!open(DUMPFILE, $input_file)) {
    die "Can't open file: $input_file\n";
}

#$title = substr($input_file, rindex($input_file, "/")+1);
#print "Markers: 1\n";
#print "YLowLimit: 0\n";
#print "XLowLimit: 0\n";
#print "XUnitText: Time (s)\n";
#print "YUnitText: Number\n";
#print "Device: Postscript\n";
#print "Disposition: To Device\n";
#print "NoLines: 1\n";
#print "FileOrDev: moon\n";
#print "TitleText: $title\n";

print "newgraph \n";
print "(* title : $ARGV[0] *)\n";
print "xaxis size 3.3 label : time (s), relative to initial ftp start\n";
print "yaxis size 2.4 label : FTP KB received\n";
print "newcurve marksize 0.01 0.001 color 0 0 0 pts\n";


# data packets
#print "\n\"sequence\n";
$maxseq = 0;
$cnt =0;
while (<DUMPFILE>) {
                # non - acks; acks are processed later.
                #   hr:min:(sec.usec)      addr.prt          dest.prt      flg   strt:end
    if (/\d+:(\d+):([\d.]+)\s+([\w\d-.]+)\s+>\s+([\w\d-.]+):\s+(\S)+\s+\d+:(\d+)/) {
        my $minutes = $1;
        my $time = $1*60+$2;
        my $src = $3;
        my $dst = $4;
  my $flag = $5;
        my $seq = $6;
        $seq = 0 if($flag eq "S");

        if (!defined($first_min)) {
            $first_min = $time/60.0;
        }
        #if (match($src, $dst, $sender, $acker)) {
        if ($src =~ /\.(ftp-data|20)$/) {
			      $maxseq = $seq if($maxseq < $seq);
            $time = $time - 60*($first_min);
                        $time += 3600 if($time < 0) ;
            print "$time " .($seq/1024) ."\n";
			if(defined($lseq{$dst}) && ($lseq{$dst} == $seq)) {
				$dupe{$dst}++;
			} else {
				if(defined($dupe{$dst}) && ($dupe{$dst} >= 2)) {
					# this was a double duplicate packet 
					print STDERR "duplicate packet $lseq{$dst} at $lseqtime{$dst} on $dst  $dupe{$dst}\n";
					push (@outerrexmitlist, $lseqtime{$dst}) ;
				}
				$lseq{$dst} = $seq;
				$lseqtime{$dst} = $time;
				$dupe{$dst} = 1;
			}
        }
        $cnt ++;
    }
}

print "\n(* label : $cnt packets *)\n";
# acks

print "newcurve marktype none pts 0 0\n";

#if($ARGV[0] !~ /poplar/) {
        #exit;
#}

seek(DUMPFILE, 0, 0);
#print "\n\"ack\n";
print "\nnewcurve marksize 0.01 0.001 color 0.6 0.6 0.6 pts\n" if($printacks);
while (<DUMPFILE>) {
    if (/\d+:(\d+):([\d.]+)\s+([\w\d-.]+)\s+>\s+([\w\d-.]+):\s+(\S+)\s+ack\s+(\d+)\s+win\s+(\d+)/ ||
        /\d+:(\d+):([\d.]+)\s+([\w\d-.]+)\s+>\s+([\w\d-.]+):\s+(\S+)\s+\d+:\d+\(\d+\)\s+ack\s+(\d+)\s+win\s+(\d+)/) {
        my $minutes = $1;
        my $time = ($1*60)+$2;
        my $src = $3;
        my $dst = $4;
        my $flag = $5;
        my $ack = $6;
        my $rwin = $7;
        $ack=0 if($flag eq "S");
        if ($dst =~ /\.(ftp-data|20)$/) {
        #if (match($src, $dst, $acker, $sender)) {
			# why are these rules here?
        #    if (($ack != $last_ack) || (/sack/) ||
        #        ($rwin <= $last_rwin)) {
            $time = $time - (60*$first_min);
            if($printacks && $ack < 100000000)  {
             print "$time ". ($ack/1024) . "\n";
            }
			if(defined($lack{$src}) && ($lack{$src} == $ack)) {
				$dupe{$src}++;
			} else {
				if(defined($dupe{$src}) && ($dupe{$src} >= 3)) {
					# this was a triple duplicate ack 
					#print STDERR "duplicate $ack/$lack{$src} at $lacktime{$src} on $src  $dupe{$src}\n";
					push (@outerdroplist, $lacktime{$src}) ;
				}
				$lack{$src} = $ack;
				$lacktime{$src} = $time;
				$dupe{$src} = 1;
			}
			
            $last_ack = $ack;
            $last_rwin = $rwin;
    	    $ackcnt ++;
                
        }
    }
}
print "\n(* label : $ackcnt acks *)\n";

if($printdrops) {
  print "newcurve marktype cross linetype none pts\n";
  foreach $drop (@outerdroplist) {
    print "$drop 0 \n";
  }

  print "newcurve marktype cross linetype none pts\n";
  foreach $drop (@outerrexmitlist) {
    print "$drop " . ($maxseq/1024) .  "\n";
  }
}

# receiver window
if ($rwin == 1) {
    seek(DUMPFILE, 0, 0);
    #print "\n\"rwin\n";
    print "\nnewgraph y_translate 3.3 newcurve pts\n";
    while (<DUMPFILE>) {
        if (/wscale\s+(\d+)/) {
            my $pend_rscale = $1;
            if (/\d+:\d+:[\d.]+\s+([\w\d-.]+)\s+>\s+([\w\d-.]+):/) {
                my $src = $1;
                my $dst = $2;
                if (match($src, $dst, $acker, $sender)) {
                    $rscale = $pend_rscale;
                }
            }
        } elsif (/\d+:(\d+):([\d.]+)\s+([\w\d-.]+)\s+>\s+([\w\d-.]+):\s+\S+\s+ack\s+(\d+)\s+win\s+(\d+)/) {
            my $minutes = $1;
            #my $time = $2;
            my $time = ($1*60)+$2;
            my $src = $3;
            my $dst = $4;
            my $ack = $5;
            my $adv = $6;
            if (match($src, $dst, $acker, $sender)) {
               # my $advertisement = $adv * (2 ** $rscale) + $ack;
                my $advertisement = $adv * (2 ** $rscale) ;
                $time = $time - 60*($first_min);
                print "$time $advertisement\n";
            }
        }
    }
    print "(* label : rwin *) \n"
}

# SACKs
if ($sack == 1) {

    # start of SACK block
    seek(DUMPFILE, 0, 0);
    print "\n\"SACK start\n";
    while (<DUMPFILE>) {
        if (! /sackOK/ && /sack\s+(.+)[,>]/) {
            my $blocks = $1;
            if (/\d+:(\d+):([\d.]+)\s+([\w\d-.]+)\s+>\s+([\w\d-.]+):/) {
                my $minutes = $1;
                my $time = $2;
                my $src = $3;
                my $dst = $4;
                if (match($src, $dst, $acker, $sender)) {
                    while ($blocks =~ /(\d+)[:@]\d+/) {
                        my $start = $1;
                        my $printtime = $time + 60*($minutes - $first_min);
                        $blocks = $';
                        print "$printtime $start\n";
                    }
                }
            }
        }
    }

    # end of SACK block
    seek (DUMPFILE, 0, 0);
    print "\n\"SACK end\n";
    while (<DUMPFILE>) {
        if (! /sackOK/ && /sack\s+(.+)[,>]/) {
            my $blocks = $1;
            if (/\d+:(\d+):([\d.]+)\s+([\w\d-.]+)\s+>\s+([\w\d-.]+):/) {
                my $minutes = $1;
                my $time = $2;
                my $src = $3;
                my $dst = $4;
                if (match($src, $dst, $acker, $sender)) {
                    while ($blocks =~ /\d+[:@](\d+)/) {
                        my $end = $1;
                        my $printtime = $time + 60*($minutes - $first_min);
                        $blocks = $';
                        print "$printtime $end\n";
                    }
                }
            }
        }
    }

}


if($ARGV[0] =~ /U/ ) {
        print "newcurve linetype none marktype none pts 0 0\n100 0\n";
}



